'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _stcPlugin = require('stc-plugin');

var _stcPlugin2 = _interopRequireDefault(_stcPlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//babel not export default property
//so can not use `import babel from 'babel-core'`
var babel = null;

var defaultPresets = ['es2015-loose', 'stage-1'];
var defaultPlugins = ['transform-runtime'];

/**
 * Use babel to transpile ES6+ to ES5 
 */

var BabelPlugin = function (_Plugin) {
  (0, _inherits3.default)(BabelPlugin, _Plugin);

  function BabelPlugin() {
    (0, _classCallCheck3.default)(this, BabelPlugin);
    return (0, _possibleConstructorReturn3.default)(this, _Plugin.apply(this, arguments));
  }

  /**
   * run
   */

  BabelPlugin.prototype.run = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      var content, presets, plugins, data;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!babel) {
                babel = require('babel-core');
              }

              _context.next = 3;
              return this.getContent('utf8');

            case 3:
              content = _context.sent;
              presets = this.options.presets || [];

              if (presets[0] === true) {
                presets = presets.slice(1);
              } else {
                presets = defaultPresets.concat(presets);
              }

              plugins = this.options.plugins || [];

              if (plugins[0] === true) {
                plugins = plugins.slice(1);
              } else {
                plugins = defaultPlugins.concat(plugins);
              }
              data = babel.transform(content, {
                filename: this.file.path,
                presets: presets,
                plugins: plugins,
                sourceMaps: this.options.sourceMap,
                sourceFileName: this.file.path
              });
              return _context.abrupt('return', { content: data.code });

            case 10:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function run() {
      return _ref.apply(this, arguments);
    }

    return run;
  }();
  /**
   * update
   */


  BabelPlugin.prototype.update = function update(data) {
    this.setContent(data.content);
    this.file.extname = this.options.extname || 'js';
  };
  /**
   * cache
   */


  BabelPlugin.cache = function cache() {
    return true;
  };
  /**
   * use cluster to compile it
   */


  BabelPlugin.cluster = function cluster() {
    return true;
  };

  return BabelPlugin;
}(_stcPlugin2.default);

exports.default = BabelPlugin;
//# sourceMappingURL=index.js.map